(* Tactics to handle the alwaysexample.
 *)

fun initial_proof_part pos =
    t_compose_l
	[box_r pos,
	 apply_to_end_l transrel_l,
	 approx_r pos
	 ]

fun handle_spec_r pos =
    t_compose_l
	[t_succeed (unfold_r pos),
	 apply_r pos,
	 cases_r pos,
	 true_r pos
	 ]

fun the_proof_step pos =
    t_compose_l
	[unfold_app_r pos,
	 apply_r pos,
	 t_compose
	     (and_r pos)
	     [handle_spec_r pos,
	      t_compose2
		  (box_r pos)
		  (apply_to_end_l transrel_l)
	      ]
	 ]
