fun repeat f =
    if f() then 
	repeat f
    else
	()

fun advance pos =
    t_compose_l
	[unfapp_l pos,
	 (t_compose
	      (or_l pos)
	      [simplify_tacs [array_contains_l, unfapp_l] [],
	       (t_compose_l
		    [and_l pos,
		     weak_l pos,
		     apply_l pos,
		     forall_l NONE pos,
		     (t_compose
			  (implication_l pos)
			  [apply_to_end_r transrel_r,
			   t_skip])
		     ])
	       ])
	 ]

fun Advance pos = 
    (by(advance pos)
     )

(* Old, stupid, slow version.
 * better to use weakening
fun advance1 pos =
    t_compose_l
	[unfapp_l pos,
	 t_compose
	     (or_l pos)
	     [simplify_tacs [array_contains_l, unfapp_l] [],
	      simplify_tacs [transrel_l, unfapp_l] []
	      ]
	 ]

fun advance2 pos =
    t_compose_l
	[apply_l pos,
	 forall_l NONE pos,
	 t_compose
	     (implication_l pos)
	     [apply_to_end_r transrel_r,
	      t_skip
	      ]
	 ]

fun Advance pos =
    ((* This rule will generate multiple identical goals,
      (from the diamond), one per thread in the system. *)
     by(advance1 pos);
     (* Remove theese extraneous goals here.*)
     repeat copydischarge1;
     by(advance2 pos)
     )
*)

fun always_advance pos = 
    t_compose2 
	(unfapp_r pos) 
	(t_compose 
	     (and_r pos) 
	     [true_r pos, 
	      (t_compose2 
		   (box_r pos) 
		   (transrel_l pos))
	      ]
	     )

fun always_Advance pos = by(always_advance pos);
